<?php  namespace App\Controllers\Tarifas;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Tarifas\TarifaEnvioEntity;

use App\Models\Configuracion\PaisModel;
use App\Models\Compras\ProveedorModel;
use App\Models\Compras\ProveedorTipoModel;

use App\Models\Tarifas\TarifaEnvioModel;
use App\Models\Tarifas\TarifaEnvioPrecioModel;
use App\Models\Tarifas\TarifaEnvioZonaModel;

class Tarifasenvios extends \App\Controllers\BaseResourceController {

    protected $modelName = TarifaEnvioModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Tarifa Envio';
    protected static $singularObjectNameCc = 'tarifaEnvio';
    protected static $pluralObjectName = 'Tarifa Envio';
    protected static $pluralObjectNameCc = 'tarifaEnvio';

    protected static $controllerSlug = 'tarifasenvios';

    protected static $viewPath = 'themes/vuexy/form/tarifas/envios/';

    protected $indexRoute = 'tarifaEnvioList';

    

    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger) {
        $this->viewData['pageTitle'] = lang('TarifasEnvios.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;

        $this->viewData = ['usingServerSideDataTable' => true]; // JJO

        // Breadcrumbs
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_tarifas"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_tarifaenvio"), 'route' => site_url('tarifas/tarifasenvios'), 'active' => true]
        ];

        parent::initController($request, $response, $logger);
    }


    public function index() {

        // Check if the user is allowed to list items
        checkPermission('tarifa-envio.menu');

        $viewData = [
                'currentModule' => static::$controllerSlug,
                'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('TarifasEnvios.tarifaEnvio')]),
                'tarifaEnvioEntity' => new TarifaEnvioEntity(),
                'usingServerSideDataTable' => true,
                
            ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath.'viewTarifaEnvioList', $viewData);
    }


    public function add() {

        checkPermission('tarifa-envio.create', $this->indexRoute);

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();
            
			$sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            if (isset($this->model->user_updated_id)) {
                $sanitizedData['user_created_id'] = auth()->user()->id;
            }

            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :


				if ($this->canValidate()) :
					try {
						$successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
					} catch (\Exception $e) {
						$noException = false;
						$this->dealWithException($e);
					}
				else:
					$this->viewData['errorMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio'))]);
						$this->session->setFlashdata('formErrors', $this->model->errors());
				endif;
            
            $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio'))]).'.';
                $message .= anchor( "admin/tarifasenvios/{$id}/edit" , lang('Basic.global.continueEditing').'?');
                $message = ucfirst(str_replace("'", "\'", $message));

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(site_url('tarifas/tarifasenvios/edit/' . $id))->with('sweet-success', $message);
                        //return redirect()->to(route_to( $this->indexRoute )  )->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEnvioEntity'] = isset($sanitizedData) ? new TarifaEnvioEntity($sanitizedData) : new TarifaEnvioEntity();
		$this->viewData['paisList'] = $this->getPaisListItems();

        $this->viewData['formAction'] = route_to('createTarifaEnvio');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew').' '.lang('TarifasEnvios.moduleTitle').' '.lang('Basic.global.addNewSuffix');
        

        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null) {

        checkPermission('tarifa-envio.edit', $this->indexRoute);

        
        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $tarifaEnvioEntity = $this->model->find($id);

        if ($tarifaEnvioEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        

        if ($this->request->getPost()) :

            $nullIfEmpty = true; // !(phpversion() >= '8.1');
        
            $postData = $this->request->getPost();
            
            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);

            // JJO
            if (isset($this->model->user_updated_id)) {
                $sanitizedData['user_updated_id'] = auth()->user()->id;
            }
            
            $noException = true;
            if ($successfulResult = $this->canValidate()) : // if ($successfulResult = $this->validate($this->formValidationRules) ) :
            
            

            	if ($this->canValidate()) :
            	    try {
            	        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
            	    } catch (\Exception $e) {
            	        $noException = false;
            	        $this->dealWithException($e);
            	    }
            	else:
            	    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio'))]);
            	    $this->session->setFlashdata('formErrors', $this->model->errors());
            	
            	endif;
            	
            	$tarifaEnvioEntity->fill($sanitizedData);

            	$thenRedirect = false;
            endif;
            if ($noException && $successfulResult) :
                $id = $tarifaEnvioEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [mb_strtolower(lang('TarifasEnvios.tarifaEnvio'))]).'.';
                //$message .= anchor( "admin/tarifasenvios/{$id}/edit" , lang('Basic.global.continueEditing').'?');
                $message = ucfirst(str_replace("'", "\'", $message));

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to( $this->indexRoute )  )->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;
        
            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['tarifaEnvioEntity'] = $tarifaEnvioEntity;
		$this->viewData['paisList'] = $this->getPaisListItems();

        $this->viewData['formAction'] = route_to('updateTarifaEnvio', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2').' '.lang('TarifasEnvios.moduleTitle').' '.lang('Basic.global.edit3');
        
         //JJO
         $this->viewData['proveedores'] = $this->getProveedores();
        
        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)
    

    // JJO
    public function delete($id = null)
    {
        /*if (!auth()->user()->can('tarifa-envio.delete')) {
            return $this->fail('Error');
        }*/

        if (!empty(static::$pluralObjectNameCc) && !empty(static::$singularObjectNameCc)) {
            $objName = mb_strtolower(lang(ucfirst(static::$pluralObjectNameCc).'.'.static::$singularObjectNameCc));
        } else {
            $objName = lang('Basic.global.record');
        }
        
        if (!$this->soft_delete){

            if (!$this->model->delete($id)) {
                return $this->failNotFound(lang('Basic.global.deleteError', [$objName]));
            }
        }
        else{
            $datetime = (new \CodeIgniter\I18n\Time("now"));

            $zonaModel = new TarifaEnvioZonaModel();
            $zonaResult = $zonaModel->removeAllZonasLineas($id, $datetime, $this->delete_flag);

            $precioModel = new TarifaEnvioPrecioModel();
            $precioResult = $precioModel->removeAllPrecioLineas($id, $datetime, $this->delete_flag);

            $rawResult = $this->model->where('id',$id)
                ->set(['deleted_at' =>  $datetime->format('Y-m-d H:i:s'),
                        'is_deleted' => $this->delete_flag])
                ->update();

            if (!$rawResult && !$precioResult && !$zonaResult) {
                return $this->failNotFound(lang('Basic.global.deleteError', [$objName]));
            }

        }
        
        // $message = lang('Basic.global.deleteSuccess', [$objName]); IMN commented
        $message = lang('Basic.global.deleteSuccess', [lang('Basic.global.record')]);
        $response = $this->respondDeleted(['id' => $id, 'msg' => $message]);
        return $response;
    }


    public function datatable() {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns']) ) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable(  [], 0, 0, $errstr ), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 0;
            $order = TarifaEnvioModel::SORTABLE[$requestedOrder >= 0 ? $requestedOrder : 0];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $resourceData = $this->model->getResource($search)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect() {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal.', nombre', 'nombre', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->nombre = '- '.lang('Basic.global.None').' -';
            array_unshift($menu , $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems() {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'nombre'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- '.lang('Basic.global.None').' -';
            array_unshift($menu , $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


	protected function getPaisListItems() { 
		$paisModel = model('App\Models\Configuracion\PaisModel');
		$onlyActiveOnes = true;
		$data = $paisModel->getAllForMenu('id, nombre','nombre', $onlyActiveOnes );

		return $data;
	}

    private function getProveedores(){
        $provTipoModel = new ProveedorTipoModel();
        $provModel = new ProveedorModel();

        $tipoId = $provTipoModel->getTipoId("Transporte");
        return $provModel->getProvList($tipoId);
    }

}
